## Where can I get more information about high-throughput sequencing concepts and terms?

http://gatkforums.broadinstitute.org/gatk/discussion/1321/where-can-i-get-more-information-about-high-throughput-sequencing-concepts-and-terms

<p><strong>This article has been retired, as the resources it cites are somewhat out of date. For an introduction to GATK and sequence analysis, see the Best Practices section of the website, which contains a lot of intro-level information and references useful resources.</strong></p>
<p>We know this field can be confusing or even overwhelming to newcomers, and getting to grips with a large and varied toolkit like the GATK can be a big challenge. We have produced a presentation that we hope will help you review all the background information that you need to know in order to use the GATK:</p>
<ul>
<li>Introduction to High-Throughput Sequencing Analysis: all you need to know to use the GATK: <a href="http://www.broadinstitute.org/gatk/events/3093/GATKwh1-BP-0A-Intro_to_NGS.pdf">slides</a> and <a href="http://www.broadinstitute.org/videos/broade-introduction-ngs-gatk">video</a></li>
</ul>
<p>In addition, the following links feature a lot of useful educational material about concepts and terminology related to next-generation sequencing:</p>
<ul>
<li>
<p><a href="http://en.wikipedia.org/wiki/DNA_sequencing">DNA sequencing (Wikipedia)</a> </p>
<p>A basic review of the sequencing process.</p>
</li>
<li>
<p><a href="http://www.nature.com/nrg/journal/v11/n1/full/nrg2626.html">Sequencing technologies, the next generation, (M. Metzker, Nature Reviews - Genetics)</a> </p>
<p>An excellent, detailed overview of the myriad next-gen sequencing methdologies.</p>
</li>
<li>
<p><a href="http://www.nature.com/nmeth/journal/v7/n7/full/nmeth0710-495.html">Next-generation sequencing: adjusting to data overload (M. Baker, Nature Methods)</a> </p>
<p>A nice piece explaining the problems inherent in trying to analyze terabytes of data. The GATK addresses this issue by requiring all datasets be in reference order, so only small chunks of the genome need to be in memory at once, as explained <a href="http://gatkforums.broadinstitute.org/discussion/1320/how-does-the-gatk-handle-these-huge-ngs-datasets">here</a>.</p>
</li>
<li><a href="https://www.dropbox.com/s/f09g6br4bq5o7hw/NGS%20intro%20v1.pptx.pdf">Primer on NGS analysis, from Broad Institute Primers in Medical Genetics</a></li>
</ul>